<?php
header("Content-Type: text/plan; charset=UTF-8");
header("Access-Control-Allow-Origin: *");

ini_set( 'display_errors', 0 );

function escape($str) {
	return htmlentities($str, ENT_QUOTES, 'UTF-8');
}
	$format = $_REQUEST['format'];
	if ($format == ""){ $format = "csv";}

	$userId = $_REQUEST['userId'];
	$deviceId = $_REQUEST['deviceId'];
	$dataType = $_REQUEST['dataType'];
	$startDate = $_REQUEST['startDate'];
	$endDate = $_REQUEST['endDate'];
	$scale = $_REQUEST['scale'];
	$limit = $_REQUEST['limit'];
	$today = $_REQUEST['today'];
	$aggregation = $_REQUEST['aggregation'];

	try {
		$pdo = new PDO('mysql:host=localhost;dbname=test;charset=utf8','root','',
		array(PDO::ATTR_EMULATE_PREPARES => false));
	} catch (PDOException $e) {
		 exit('データベース接続失敗。'.$e->getMessage());
	}

	if ($scale == ""){ $scale = "MINUTE";}
	if ($limit == ""){ $limit = "100";}
	if ($aggregation == ""){ $aggregation = "AVG";}
	if ($aggregation != "AVG" && $aggregation != "MAX" && $aggregation != "MIN" && $aggregation != "SUM"){$aggregation = "AVG";}

	$ccdateFormat = "%Y/%m/%d %H:%i:00";
	if ($scale == "DAY"   ){ $ccdateFormat = "%Y/%m/%d 00:00:00"; }
	if ($scale == "HOUR"  ){ $ccdateFormat = "%Y/%m/%d %H:00:00"; }
	if ($scale == "MINUTE"){ $ccdateFormat = "%Y/%m/%d %H:%i:00"; }
	if ($scale == "SECOND"){ $ccdateFormat = "%Y/%m/%d %H:%i:%s"; }

	$where = "";
	if ($userId != ""){
		if ($where != ""){ $where .= " and ";}
		$where .= " t1.userId = :userId ";
	}
	if ($deviceId != ""){
		if ($where != ""){ $where .= " and ";}
		$where .= " t1.deviceId = :deviceId ";
	}
	if ($dataType != ""){
		if ($where != ""){ $where .= " and ";}
		$where .= " t1.dataType = :dataType ";
	}
	if ($startDate != ""){
		if ($where != ""){ $where .= " and ";}
		$where .= " date_format(t1.ccdate, '%Y/%m/%d') >= :startDate ";
	}
	if ($endDate != ""){
		if ($where != ""){ $where .= " and ";}
		$where .= " date_format(t1.ccdate, '%Y/%m/%d') <= :endDate ";
	}

	$sql = "select t1.userId, t1.deviceId, t1.dataType, t1.ccdate, ROUND(" . $aggregation . "(t1.value),2) as value from ";
	$sql .= " (select userId, deviceId, dataType, date_format(cdate,'".$ccdateFormat."') as ccdate, value from detail ) as t1";
	if ($where != ""){ $sql .= " where ".$where; }
	$sql .= " group by t1.userId, t1.deviceId, t1.dataType, t1.ccdate";
	$sql .= " order by t1.ccdate desc";
	$sql .= " limit :limit";
	
	# print $sql . "\n";
	$stmt = $pdo->prepare($sql);
	$stmt->bindParam(':userId',    $userId,    PDO::PARAM_STR);
	$stmt->bindParam(':deviceId',  $deviceId,  PDO::PARAM_STR);
	$stmt->bindParam(':dataType',  $dataType,  PDO::PARAM_STR);
	$stmt->bindParam(':startDate', $startDate, PDO::PARAM_STR);
	$stmt->bindParam(':endDate',   $endDate,   PDO::PARAM_STR);
	$stmt->bindParam(':limit',     $limit,     PDO::PARAM_STR);

	$stmt->execute();
	$array = array();
	while($row = $stmt -> fetch(PDO::FETCH_ASSOC)) {
		# print(escape($row["userId"]).",");
		# print(escape($row["deviceId"]).",");
		# print(escape($row["dataType"]).",");
		# print(escape($row["ccdate"]).",");
		# print(escape($row["value"])."\n");
		$data = array(
			'userId' => $row["userId"],
			'deviceId' => $row["deviceId"],
			'dataType' => $row["dataType"],
			'ccdate' => $row["ccdate"],
			'value' => $row["value"]
		);
		$array[] = $data;

	}
	# print_r($array);

	if ($format == "csv"){
		print "userId,deviceId,dataType,ccdate,value\n";
		$count = count($array);
		for ($i = 0; $i < $count; $i++) {
			$row = $array[$i];
			print(escape($row["userId"]).",");
			print(escape($row["deviceId"]).",");
			print(escape($row["dataType"]).",");
			print(escape($row["ccdate"]).",");
			print(escape($row["value"])."\n");
		}

	} else 
	if ($format == "json"){
		header("Content-Type: text/javascript; charset=UTF-8");
		$json = json_encode( $array );
		print $json;
	} else 
	{
		print "unknown format type:".$format."\n";
	}
?>
