<?php
header("Content-Type: text/html; charset=UTF-8");
?>
<html>
<head>
<title>Heat Map</title>
<script type="text/javascript" src='http://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js'></script>
<script src="http://code.highcharts.com/highcharts.js"></script>
<script src="http://d3js.org/d3.v3.min.js" charset="utf-8"></script>

<?php
ini_set( 'display_errors', 1 );
?>

<script>
function init(){
	drawHeatmap();
}
var svg = null;
var points = null;
function drawHeatmap(){

	svg = d3.select("#view").selectAll("svg").remove();		// 前回のものを削除

	$.ajax({
		type: "GET",
		url: "./details.php",
		// url: "http://aramoto.sakura.ne.jp/IoT/details.php",
		// url: "./details.txt",
		cache: false,
		data: {
			"userId": "U000000001",
			"deviceId": $("#deviceId").val(),
			"dataType": $("#dataType").val(),
			"startDate": $("#startDate").val(),
			"endDate": $("#endDate").val(),
			"scale": $("#scale").val(),
			"limit": $("#limit").val(),
			"aggregation": $("#aggregation").val(),
		},
		success: function(data){
				// console.log(data);

				svg = d3.select("#view").append("svg")  // <div id="view">に<svg>を追加
					.attr("width", 1500)
					.attr("height", 700);

				var startDate = null;
				points = new Array();
				var lines = csvToArray(data);
				for (i = 1 ; i < lines.length ; i++){
					var csv = lines[i];
					var key = csv["userId"] + " " + csv["deviceId"] + " " + csv["dataType"];
					// console.log(key);
					
					var point = new Array();
					point["key"] = key;
					point["type"] = csv["dataType"];
					point["date"] = csv["ccdate"];
					point["value"] = parseFloat(csv["value"]);

					// 日時からX,Yに変換
					var date = (new Date(csv["ccdate"])).getTime() + 9*60*60*1000;    // 時刻を日本時間にする
					if (startDate == null){ startDate = date;}
					var y = -(Math.floor(date / (60*60*24*1000)) - Math.floor(startDate / (60*60*24*1000)));	// 0 -> 日数分
					var x = Math.floor((date % (60*60*24*1000)) / 1000 / 60);   // 0 -> 24*60
					// console.log(csv["ccdate"] + ":" + date + ":" + y + ":" + x + ":" + csv["value"]);
					point["y"] = y;
					point["x"] = x;

					points.push(point);
				}
				
				// キーごとに最大値と最小値を出し、％表記に変換する
				var maxs = new Array();
				var mins = new Array();
				points.forEach(function(point){
					var key = point["key"];
					var value = point["value"];
					var max = maxs[key];
					if (max == null || max < value){ maxs[key] = value;}
					var min = mins[key];
					if (min == null || min > value){ mins[key] = value;}
				});
				points.forEach(function(point){
					var key = point["key"];
					var max = maxs[key];
					var min = mins[key];
					point["max"] = max;
					point["min"] = min;
					if (max != min){
						point["p"] = (point["value"] - min) / (max - min);
					} else {
						point["p"] = 1;
					}
				});
				// console.log(points);

				svg.selectAll(".node")
					.data(points).enter()
					.append("rect")										// 矩形
					.attr("class", "node")
					.attr("x", function(d) {							// 矩形の座標
						var m = 0;
						if (d.type == "TEMP"){ m = 0;}
						if (d.type == "ACCL"){ m = 10;}
						if (d.type == "MOTION"){ m = 20;}
						if (d.type == "WATT"){ m = 30;}
						d.cx1 = (d.x / 60 / 24)*(10*24)     + 5;
						d.cx4 = (d.x / 60 / 24)*(50*24) + m + 5;
						d.cx = d.cx4;
						return d.cx;
					})
					.attr("y", function(d) { d.cy = (d.y * 10 + 15); return d.cy; }) 	// 矩形の座標
					.attr("width", 10)
					.attr("height", 10)	
					.style("stroke", function(d) {							// 枠線の色
						var date = new Date(d.date);
						if (date.getDay() == 6){		// 土
							return "rgb(  0, 0, 200)";
						}
						if (date.getDay() == 0){		// 日
							return "rgb(  200, 0, 0)";
						}
						if (d.type == "TEMP"  ){ return "rgb(128, 0, 0)"; }
						if (d.type == "ACCL"  ){ return "rgb(  0, 0, 128)"; }
						if (d.type == "MOTION"){ return "rgb(  0, 128, 0)"; }
						if (d.type == "WATT"  ){ return "rgb(128, 128, 0)"; }
					})
					.style("stroke-width", "1px")							// 枠線の太さ
					.style("fill", function(d) {							// 塗りつぶしの色
						if (d.type == "TEMP"  ){ return "rgba(255, 0, 0, " + (d.p) + ")"; }
						if (d.type == "ACCL"  ){ return "rgba(0, 0, 255, " + (d.p) + ")"; }
						if (d.type == "MOTION"){ return "rgba(0, 255, 0, " + (d.p) + ")"; }
						if (d.type == "WATT"  ){ return "rgba(255, 255, 0, " + (d.p) + ")"; }
						return "white";
					})
					.on('click', function(d) {
						console.log(d);
						infos = [{type:d.type, date:d.date, value:d.value, x:d.cx, y:d.cy, }];
						svg.selectAll(".info1")
							.data(infos)
							.transition().duration(500)
							.attr("x",function(d) { return d.x + 5; })
							.attr("y",function(d) { return d.y + 5; })
							.text(function(d) { return d.value + " " + d.date + " " + d.type; })
						;
						svg.selectAll(".info2")
							.data(infos)
							.transition().duration(500)
							.attr("x",function(d) { return d.x + 5; })
							.attr("y",function(d) { return d.y + 5; })
							.text(function(d) { return d.value + " " + d.date + " " + d.type; })
						;
							
					})
				;

				// テキスト表示用を作成
				infos = [{type:"", date:"", value:"", }];
				svg.selectAll(".info1")
					.data(infos).enter()
					.append("text")
					.attr("class", "info1") 
					.attr("x",function(d) { return -100; })
					.attr("y",function(d) { return -100; })
					.style("font", "8pt sans-serif")
					.style("stroke", "white")
					.style("stroke-width", "3px")
					.text(function(d) { return ""; })
				;
				svg.selectAll(".info2")
					.data(infos).enter()
					.append("text")
					.attr("class", "info2") 
					.attr("x",function(d) { return -100; })
					.attr("y",function(d) { return -100; })
					.style("font", "8pt sans-serif")
					.style("stroke", "black")
					.style("stroke-width", "1px")
					.text(function(d) { return ""; })
				;
				
				$("#type").val("ALL");
				$("#day").val("ALL");
		},
	});
}

function changeType(){
	var type = $("#type").val();
	svg.selectAll(".node")
		.data(points)
		.transition().duration(500)
		.attr("x",function(d) {
			if (type == "ALL"){
				d.cx = d.cx4;
			} else if (type == "SPLIT"){
				d.cx = d.cx1;
				if (d.type == "TEMP"){
				} else if (d.type == "ACCL"){
					d.cx = d.cx + (10*24+10) * 1;
				} else if (d.type == "MOTION"){
					d.cx = d.cx + (10*24+10) * 2;
				} else if (d.type == "WATT"){
					d.cx = d.cx + (10*24+10) * 3;
				}
			} else if (d.type == type){
				d.cx = d.cx1;
			} else {
				d.cx = -100;	// 隠す
			}
			return d.cx;
		})
	;

	hideInfo();
}

function changeDay(){
	var day = $("#day").val();
	svg.selectAll(".node")
		.data(points)
		.transition().duration(500)
		.attr("y",function(d) {
			var date = new Date(d.date);
			if (day == "ALL"){
				return d.cy;
			} else if (day == "DAY1"){		// 月～金
				if (1 <= date.getDay() && date.getDay() <= 5){
					return d.cy;
				} else {
					return -100;			// 隠す
				}
			} else if (day == "DAY2"){		// 土日
				if (date.getDay() == 0 || date.getDay() == 6){
					return d.cy;
				} else {
					return -100;			// 隠す
				}
			} else if (day == "DAY3"){		// 土
				if (date.getDay() == 6){
					return d.cy / 7;
				} else {
					return -100;			// 隠す
				}
			} else if (day == "DAY4"){		// 日
				if (date.getDay() == 0){
					return d.cy / 7;
				} else {
					return -100;			// 隠す
				}
			} else {
				return -100;			// 隠す
			}
		})
	;
	
	hideInfo();
}

function hideInfo(){
		infos = [{Name:"ダミー", }];
		svg.selectAll(".info1")
			.data(infos)
			.attr("x",function(d) { return -100; })
			.attr("y",function(d) { return -100; })
			.text(function(d) { return d.Name; })
		;
		svg.selectAll(".info2")
			.data(infos)
			.attr("x",function(d) { return -100; })
			.attr("y",function(d) { return -100; })
			.text(function(d) { return d.Name; })
		;
}

// 簡易版CSV→Array変換
// １行目はヘッダ
function csvToArray(csv){
	var array = new Array();

	var lineCount = 0;
	var lines = csv.split("\n");
	var headers = lines[0].split(",", -1);
	for (var i = 0 ; i < headers.length; i++){
		headers[i] = headers[i].replace(/(^\s+)|(\s+$)/g, ""); // trim
	}

	for (var i = lineCount ; i < lines.length ; i++){
		var line = lines[i];
		if (line.length <= 1) continue;
		var cols = line.split(",", -1);
		var json = new Object();
		for (var j = 0 ; j < cols.length ; j++){
			json[headers[j]] = cols[j].replace(/(^\s+)|(\s+$)/g, "");
		}
		array.push(json);
	}

	return array;
}

</script>
</head>
<body onload="init()">
<div id='container'></div>

<form methond="GET">
<input type="submit" value="更新" onclick="drawHeatmap(); return false;">&nbsp;&nbsp;
<select name="aggregation" id="aggregation">
	<option value="AVG" selected>AVG</option>
	<option value="MAX">MAX</option>
	<option value="MIN">MIN</option>
	<option value="SUM">SUM</option>
</select>&nbsp;&nbsp;
scale:<input type="text" name="scale" id="scale" value="HOUR">&nbsp;&nbsp;
limit:<input type="text" name="limit" id="limit" value="10000"><br/>
</form>
<select name="type" id="type" onchange="changeType();">
	<option value="ALL" selected>ALL</option>
	<option value="SPLIT">SPLIT</option>
	<option value="TEMP">TEMP</option>
	<option value="ACCL">ACCL</option>
	<option value="MOTION">MOTION</option>
	<option value="WATT">WATT</option>
</select>
<select name="day" id="day" onchange="changeDay();">
	<option value="ALL" selected>月～金土日</option>
	<option value="DAY1">月～金のみ</option>
	<option value="DAY2">土日のみ</option>
	<option value="DAY3">土のみ</option>
	<option value="DAY4">日のみ</option>
</select>
<div id="view"></div>
</body>
</html>
