<?php
header("Content-Type: text/html; charset=UTF-8");
?>
<html>
<head>
<title>IoT</title>
<script type="text/javascript" src='./highcharts/jquery.min.js'></script>
<script src="./highcharts/highcharts.js"></script>
<script>

<?php
ini_set( 'display_errors', 0 );

	$mainDataType = $_REQUEST['mainDataType'];
	if ($mainDataType == ''){ $mainDataType = "TEMP";}
?>

var chart = null;
var mainDataType = null;

function init(){
	drawChart();
}
function drawChart(){

	if (chart != null){
		chart.setTitle({ text: 'データロード中' });
	}
	mainDataType = $("#mainDataType").val();

	$.ajax({
		type: "GET",
		url: "./details.php",
		//url: "http://aramoto.sakura.ne.jp/IoT/details.php",
		cache: false,
		data: {
			"userId": $("#userId").val(),
			"deviceId": $("#deviceId").val(),
			"dataType": $("#dataType").val(),
			"startDate": $("#startDate").val(),
			"endDate": $("#endDate").val(),
			"scale": $("#scale").val(),
			"limit": $("#limit").val(),
		},
		success: function(data){

			var contents = new Array();
			var lines = csvToArray(data);
			for (i = 1 ; i < lines.length ; i++){
				var csv = lines[i];
				var key = csv["userId"] + " " + csv["deviceId"] + " " + csv["dataType"];
				var ccdate = csv["ccdate"].replace(/-/g,"/");
				var value = csv["value"];
				var d = new Array();
				d[0] = (new Date(ccdate)).getTime() + 9*60*60*1000;    // 時刻を日本時間にする
				d[1] = Number(value);
				
				content = contents[key];
				if (content == null){
					content = new Array();
					contents[key] = content;
				}
				content.push(d);
			}
			console.log(contents);
		
			// 表示データをセット
			series = new Array();
			var keys = new Array();		// キー名でソートしたい
			for (var key in contents){
				if (key == "") continue;	// 空文字が入っている場合は、捨てる
				keys.push(key);
			}
			keys.sort();
			for (var i = 0 ; i < keys.length ; i++){
				var key = keys[i];
				var content = contents[key];
				content.sort( function(a,b){
						if( a[0] < b[0] ) return -1;
						if( a[0] > b[0] ) return 1;
						return 0;
				});
				var yAxis = 0;		// Y軸のメモリを左側にするか、右側にするか
				if (key.split(" ")[2] != mainDataType){ yAxis = 1;}

				var color = null;		// 線の色を決める
				if (key.split(" ")[2] == "TEMP"){ color="#ff0000";}
				if (key.split(" ")[2] == "ACCL"){ color="#0000ff";}
				if (key.split(" ")[2] == "MOTION"){ color="#00ff00";}
				if (key.split(" ")[2] == "WATT"){ color="#dddd00";}

				series[i] = {name:key, yAxis:yAxis, data:content, color:color, };
			}
		
		
			// 補助線を作成
			var dates = new Array();	// データ中の日だけ集める
			for (i = 1 ; i < lines.length ; i++){
				var csv = lines[i];
				var ccdate = csv["ccdate"].replace(/-/g,"/");
				var date = ccdate.split(" ")[0];
				dates[date] = date;
			}
			xPlotLines = new Array();
			for (var date in dates){
				var time = (new Date(date)).getTime() + 9*60*60*1000;    // 時刻を日本時間にする
				var day = (new Date(date)).getDay();
				var color = 'gray';
				if (day == 0){ color = 'red';}
				if (day == 6){ color = 'blue';}
				plot = 
					{	value : time,
						color : color,
						dashStyle : 'Dot',
						width : 1,
					};
				xPlotLines.push(plot);
			}
			console.log(xPlotLines);
		
			
			// グラフを作成
			chart = new Highcharts.Chart({
				chart: {
					renderTo: container,
					defaultSeriesType: "line",
		//			marginRight: 170,
					marginBottom: 50,
					zoomType: "x",
					borderWidth: 3,
					borderColor: "#000000",
					alignTicks: false,		// Y軸の左側と右側を無理して合わせない
				},
				title: {
					text: "室内情報",
					style: {
						fontSize: "36px",		// デフォルト18px
					},
					floating: true,	// 位置やマージンを無視＝subtitleに重ねて描画（縦幅が減るのを抑制）
				},
				xAxis: {
						type: 'datetime',
						title: {
							text: "日時"
						},
						dateTimeLabelFormats: {
							second: '%H:%M:%S',
							minute: '%H:%M',
							hour: '%H:%M',
							day: '%m/%e',
							week: '%Y/%m/%e',
							month: '%Y/%m/%e',
							year: '%Y',
						},
						plotLines : xPlotLines,
				},
				yAxis: [
					{
						title: {
								text: mainDataType,
								margin: 10,
						},
						// min: 0,
						// max: 40,
					},
					{
						title: {
								text: "それ以外",
								margin: 10,
						},
						// min: 0,
						opposite: true, // 右側のy軸とする
						gridLineDashStyle: "Dot",
					},
				],
				tooltip: {
					formatter: function () {
						var time = (new Date(this.x)).getTime() - 9*60*60*1000; // 元の時刻に戻す
						return '<i>' + (new Date(time)).toLocaleString() + '</i> : <b>' + this.y + '</b><br>'
					 		+ this.series.name;
					},
				},
				legend: {
						layout: "vertical",
						align: "right",
						verticalAlign: "top",
						itemStyle: {
							fontSize: '10px' // 凡例の文字サイズ
						},
				},
				series: series,
			});
		}
	});
		
		
}
		
// 簡易版CSV→Array変換
// １行目はヘッダ
function csvToArray(csv){
	var array = new Array();

	var lineCount = 0;
	var lines = csv.split("\n");
	var headers = lines[0].split(",", -1);
	for (var i = 0 ; i < headers.length; i++){
		headers[i] = headers[i].replace(/(^\s+)|(\s+$)/g, ""); // trim
	}

	for (var i = lineCount ; i < lines.length ; i++){
		var line = lines[i];
		if (line.length <= 1) continue;
		var cols = line.split(",", -1);
		var json = new Object();
		for (var j = 0 ; j < cols.length ; j++){
			json[headers[j]] = cols[j].replace(/(^\s+)|(\s+$)/g, "");
		}
		array.push(json);
	}

	return array;
}

</script>
</head>
<body onload="init()">
<div id='container'></div>

<form methond="GET">
<?php

function escape($str) {
	return htmlentities($str, ENT_QUOTES, 'UTF-8');
}

	$userId = $_REQUEST['userId'];
	$deviceId = $_REQUEST['deviceId'];
	$dataType = $_REQUEST['dataType'];
	$startDate = $_REQUEST['startDate'];
	$endDate = $_REQUEST['endDate'];
	$scale = $_REQUEST['scale'];
	$limit = $_REQUEST['limit'];

	try {
		$pdo = new PDO('mysql:host=localhost;dbname=test;charset=utf8','root','',
		array(PDO::ATTR_EMULATE_PREPARES => false));
	} catch (PDOException $e) {
		 exit('データベース接続失敗。'.$e->getMessage());
	}

	$sql = "select distinct userId from detail order by 1";
	print 'userId:<select name="userId" id="userId">';
	$stmt = $pdo->prepare($sql);
	$stmt->execute();
	print '<option value=""></option>';
	while($row = $stmt -> fetch(PDO::FETCH_ASSOC)) {
		$d = $row["userId"];
		if ($userId == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';

	$sql = "select distinct deviceId from detail order by 1";
	print 'deviceId:<select name="deviceId" id="deviceId">';
	$stmt = $pdo->prepare($sql);
	$stmt->execute();
	print '<option value=""></option>';
	while($row = $stmt -> fetch(PDO::FETCH_ASSOC)) {
		$d = $row["deviceId"];
		if ($deviceId == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';

	$sql = "select distinct dataType from detail order by 1";
	print 'dataType:<select name="dataType" id="dataType">';
	$stmt = $pdo->prepare($sql);
	$stmt->execute();
	print '<option value=""></option>';
	while($row = $stmt -> fetch(PDO::FETCH_ASSOC)) {
		$d = $row["dataType"];
		if ($dataType == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';

	$sql = "select distinct dataType from detail order by 1";
	print '主dataType:<select name="mainDataType" id="mainDataType">';
	$stmt = $pdo->prepare($sql);
	$stmt->execute();
	while($row = $stmt -> fetch(PDO::FETCH_ASSOC)) {
		$d = $row["dataType"];
		if ($mainDataType == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';
	print '<br>';

	$sql = "select distinct date_format(cdate, '%Y/%m/%d') as ccdate from detail order by 1";
	print 'startDate:<select name="startDate" id="startDate">';
	$stmt = $pdo->prepare($sql);
	$stmt->execute();
	print '<option value=""></option>';
	while($row = $stmt -> fetch(PDO::FETCH_ASSOC)) {
		$d = $row["ccdate"];
		if ($startDate == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';

	$sql = "select distinct date_format(cdate, '%Y/%m/%d') as ccdate from detail order by 1";
	print 'endDate:<select name="endDate" id="endDate">';
	$stmt = $pdo->prepare($sql);
	$stmt->execute();
	print '<option value=""></option>';
	while($row = $stmt -> fetch(PDO::FETCH_ASSOC)) {
		$d = $row["ccdate"];
		if ($endDate == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';

	if ($scale == ""){ $scale = "MINUTE";}
	print 'scale:<select name="scale" id="scale">';
	foreach (array("", "DAY", "HOUR", "MINUTE", "SECOND") as $d){
		if ($scale == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';

	if ($limit == ""){ $limit = "1000";}
	print 'limit:<select name="limit" id="limit">';
	foreach (array("500", "1000", "5000", "10000") as $d){
		if ($limit == $d){ $selected = "selected"; } else { $selected = ""; }
		print '<option value="'.escape($d).'" '.$selected.'>'.escape($d).'</option>';
	}
	print '</select>';
	print '&nbsp;&nbsp;';

	print '<input type="submit" value="更新" onclick="drawChart(); return false;"><br>';

?>
</form>
</body>
</html>
